
Dashboard - Bug #39295

Bug # 39294 (New): mgr/dashboard: Time handling

mgr/dashboard: RGW Bucket API should provide times in UTC that will be converted into local time

by Angular

04/15/2019 03:38 PM - Stephan Müller

Status: Resolved % Done: 0%

Priority: Normal   

Assignee: Alfonso Martínez   

Category: UX   

Target version: v15.0.0   

Source:  Affected Versions:  

Tags:  ceph-qa-suite:  

Backport: nautilus Pull request ID: 27617

Regression: No Crash signature (v1):  

Severity: 3 - minor Crash signature (v2):  

Reviewed:    

Description

RGW -> Bucket -> details -> 'modification time' attribute will provide the local server time instead UTC time

Related issues:

Copied to Dashboard - Backport #39502: nautilus: mgr/dashboard: RGW Bucket AP... Resolved

History

#1 - 04/16/2019 09:36 AM - Alfonso Martínez

- Assignee set to Alfonso Martínez

#2 - 04/16/2019 02:41 PM - Casey Bodley

the call path for the 'GET /admin/bucket' api looks like this:

rgw_rest_bucket.cc: RGWOp_Bucket_Info::execute()

rgw_bucket.cc: RGWBucketAdminOp::info()

rgw_bucket.cc: bucket_stats()

bucket_stats() is responsible for formatting the response:

formatter->dump_stream("mtime") << ut;

which calls the stream output operator on utime_t:

inline std::ostream& operator<<(std::ostream& out, const utime_t& t)   {

return t.localtime(out);

}

utime_t also has a gmtime() method that we could call instead, ie:

ut.gmtime(formatter->dump_stream("mtime"));

i suppose our APIs should always return dates in UTC?
#3 - 04/16/2019 05:14 PM - Casey Bodley

- Status changed from New to Fix Under Review

- Pull request ID set to 27617

discussed this in the rgw standup, and consensus was to return UTC unconditionally. i made this change in https://github.com/ceph/ceph/pull/27617

#4 - 04/17/2019 07:11 AM - Lenz Grimmer

- Target version set to v15.0.0

- Backport set to nautilus

#5 - 04/18/2019 06:49 AM - Alfonso Martínez

Backend PR:

https://github.com/ceph/ceph/pull/27617

Frontend PR:

https://github.com/ceph/ceph/pull/27669

#6 - 04/25/2019 10:20 PM - J. Eric Ivancich

- Status changed from Fix Under Review to Pending Backport

#7 - 04/26/2019 03:46 PM - Nathan Cutler

- Copied to Backport #39502: nautilus: mgr/dashboard: RGW Bucket API should provide times in UTC that will be converted into local time by Angular

added

#8 - 05/31/2019 12:22 PM - Nathan Cutler

- Status changed from Pending Backport to Resolved
